* name: dating-index.prg; february 2003; M.Ciccarelli and F. Canova, RATS version 6.0
* this version 11 december 2007; Rats version 6.2


* Version with 3 indices, all time varying. M1 model with exact factorization
* Changes in the parameter alter0 are needed to have 1, 4 and 8 steps ahead
* Parameter dim_lam must be changed to have 1 or 2 common factors
* Benchmark is with exact factorization, dim_lam = 2, 1 steps ahead
* This version does not compute impulse responses.
*
* Model is
*
* Y(t) = X(t-s)*b(t) + e(t),  with e_t ~N(0,sigma(e))
* X(t) contains lagged Y (from lag medlag to lag maxlag)
* and exogenous variables (from lag medlag to lag lag_exo)
*
* the index structure in coefficients is
* b(t) = xsi_1*lambda(t)+xsi_2*rho(t)+xsi_3*alfa(t)+u(t)
*      = M_1*theta(t)+u(t), with  u(t)~N(0,%kroneker(sigma(e),V)
* where M_1 = [xsi_1 xsi_2 xsi_3]; theta(t) = (lambda(t),rho'(t),alfa'(t))'
*
* the model is rewritten as:
* Y(t) = [X(t-s)*M_1]*theta(t) + v(t),  with v_t ~N(0,sigma_t* Omega)

* We Assume:
* theta(t) = theta(t-1)+eta(t),  with eta(t)~N(0,B2(t))
* B2(t) = arch3* B2(t-1)+ arch4* B2(0)
*
* Moreover:
* sigma_t ~ G(zeta,zeta*s_t), where s_t = (1+sigma^2*X'X)
* Omega= inv(sigma(e)) ~ W(w_0, Q_0);
* V= sigma^2*I_k; sigma^2 estimated from data or [p(sigma^2) \propto (sigma^2)^{-1};]

* B2(0) =diag[phi_1, phi_2, phi_3]; phi_1=scala1; phi_2=scala2*I_g; phi_3=scala3*I_n
* the prior on phi_1, phi_2 and phi_3 is IG(v_0/2, d_0/2)

* [in version base10tv_dif the prior for phi_2 and phi_3 is diffuse, i.e
* p(phi_2) \propto (phi_2)^{-0.5*(g+1)}; p(phi_3) \propropphi_3)^{-0.5*(n+1)} ]
*
* Here arch3; arch4; w_0; scala1; scala2; scala3; zeta are parameters set a priori.
* sigma^2, Q_0 are estimated from the data.
*
*** alternatives: 1) send sigma^2 --->0 (decomposition in indices exact)
*                 2) number of components in lambda (=1 or = 2)
*                 3) non informative B2(0)
*                 4) prior on v_t diffuse (send zeta ---> 0 )
seed 11
cal 1980 1 4
all 14 2002:4

source(noecho) cndition.src

compute beg=1980:1
compute tempend=2000:4
compute dat=tempend-beg
compute obs=tempend-beg
compute nstep=16	;*Number of response steps
smpl beg tempend
*
********** switching parameters
compute alter1=1   ;* =1 estimate sigma^2 from the data; =0 set sigma^2 =0.0001
compute dim_lam = 2 ;* change here = 1/2 if lambda has got 1/2 components
compute zeta = .00 ;* set to zero for a noninformative prior on sigma_t
compute exact = 1;* 0 = no exact; 1 = exact
*
*************** initialization
compute n = 7
compute g = 4
comput ng= n*g
compute minlag = 0
compute medlag = 1
compute maxlag = 1
compute lag_exo = 1

compute nlags=p=maxlag-medlag+1 ;* n. of lags of endogenous variables
compute p1 = lag_exo-medlag+1   ;* n. of lags of exogenous variables
comp nlags1 = 3                 ;* number of lags used in the preliminary estimation
compute d1 = 0                 ;* n. of exogenous variables
compute d = d1*p1+1             ;* exog. var times lags plus the constant
compute k1 = n*g*p+d            ;* n. of variable in each equation
compute ndraws = 2100           ;* number of draws in MCMC
compute ndraws1 = 30            ;* n. of times we repeat the MCMC
compute mindraws = 2000
compute begdraws= ndraws-mindraws ;* throw away some draws in the last iteration
				   * to compute moments of indices.
comp k_1 = n+g+dim_lam              ;* dimension of B2(0) matrix
*
************* parameter values
compute scala1=0.000001
compute scala2=0.000001
compute scala3=0.000001 ;* initial parameters for B2(0)
compute arch3 = 1.0  ;* paramet
compute arch4= 0.0   ;* for no heteroscedastic variance set arch4 = 0.0
compute w_0=n*g+50    ;* degrees of freedom for prior of var-cov matrix
compute v_0 = 1000000., d_0 = 1.0  ;* shape and scale for fi1,2,3. set to zero for a non informative prior
*
***********  data
open data indexsa.xls
data(org=obs,for=xls) /
close data

* Eliminate outliers for germany at unification, otherwise get
* a huge spike in the indices at that time.
*
statistics(noprint) gegdpg beg 1990:4
compute a1=%mean
statistics(noprint) gegdpg 1992:1 2000:4
compute a2=%mean
statistics(noprint) geeg beg 1990:4
compute a3=%mean
statistics(noprint) geeg 1992:1 2000:4
compute a4=%mean
set gegdpg 1991:1 1991:2 = a1
set gegdpg 1991:3 1991:4 = a2
set geeg 1991:1 1991:2 =a3
set geeg 1991:3 1991:4 =a4
/*
set inf_averg7 = 0.0

do i = 1,n
set inf_averg7 = inf_averg7 +(1./n)*([series] i)
end

* standardization of variables
dofor i = usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg cpg inf_averg7
stat(noprint) ([series] i)
set ([series] i) = (([series] i)-%mean)/sqrt(%variance)
*set ([series] i) = ([series] i)/sqrt(%variance)
end dofor
*/
* estimating sigma^2 and Q_0
*
*************** Q_0 is sigma_eps and omega is also initialized as Q_0
*
system(model=var1) 1 to n*g
variables  usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg
lags 1 to 1
det constant
end(system)
estimate(noprint,noftest,outsigma=sigma_eps) beg tempend
dec symm omega(ng,ng)
compute omega = inv(sigma_eps)
compute beta_ols1=%modelgetcoeffs(var1)

************* sigma^2
compute s_e = 0.0
*
if alter1==1
{
dofor i = usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg
linreg(noprint) i
# constant i{1 to nlags1}
compute s_e = s_e+(1./(n*g))*(sqrt(%seesq))
end dofor
}
if alter1==0
compute s_e = 0.0001
end if
*
************ setting up B2(0)

comp k_1 = n+g+dim_lam

dec symm big_phi(k_1,k_1) big_phiinv(k_1,k_1)
comp big_phi = %const(.0)

dec symm phi_1(dim_lam,dim_lam)
comp phi_1 = %mscalar(scala1)
compu phi_1inv = inv(phi_1)

dec symm phi_2(g,g) phi_2inv(g,g)
dec symm phi_3(n,n) phi_3inv(n,n)

compute phi_2 = %mscalar(scala2)
comp phi_2inv = inv(phi_2)

compute phi_3 = %mscalar(scala3)
comp phi_3inv = inv(phi_3)

do i = 1,dim_lam
comp big_phi(i,i) = phi_1(i,i)
end

do i = 1,g
comp big_phi(i+dim_lam,i+dim_lam) = phi_2(i,i)
end

do i = 1,n
comp big_phi(i+g+dim_lam,i+g+dim_lam) = phi_3(i,i)
end

comp big_phiinv = inv(big_phi)
*wri big_phiinv

* setting up various matrices for preliminary OLS estimation to initialize indices
* and for use in the MCMC
*
smpl(reglist)
# usinf{minlag to maxlag} usinfr{minlag to maxlag} useg{minlag to maxlag} usgdpg{minlag to maxlag} $
  jpinf{minlag to maxlag} jpinfr{minlag to maxlag} jpeg{minlag to maxlag} jpgdpg{minlag to maxlag}$
  geinf{minlag to maxlag} geinfr{minlag to maxlag} geeg{minlag to maxlag} gegdpg{minlag to maxlag}  $
  ukinf{minlag to maxlag} ukinfr{minlag to maxlag} ukeg{minlag to maxlag} ukgdpg{minlag to maxlag}   $
  frinf{minlag to maxlag} frinfr{minlag to maxlag} freg{minlag to maxlag} frgdpg{minlag to maxlag}   $
  itinf{minlag to maxlag} itinfr{minlag to maxlag} iteg{minlag to maxlag} itgdpg{minlag to maxlag}    $
  cainf{minlag to maxlag} cainfr{minlag to maxlag} caeg{minlag to maxlag} cagdpg{minlag to maxlag}     $
  constant

MAKE(transpose) Y
# usinf usinfr useg usgdpg $
  jpinf jpinfr jpeg jpgdpg geinf geinfr geeg gegdpg $
  ukinf ukinfr ukeg ukgdpg frinf frinfr freg frgdpg $
  itinf itinfr iteg itgdpg cainf cainfr caeg cagdpg

comp ti = %cols(y)

DEC VEC[REC] XX(N+1)
dec vec hetero_old(ti)
dec vec hetero_can(ti)
dec vec hetero(ti)
dec rec hetero_dra(ti,ndraws)

comp hetero = %const(s_e)
dec vec s_t(ti)
dec vec[vec] ss_t(i)
*
dec rec[series] general1(ti,dim_lam)
dec rect[series] general2(ti,n)
dec rec[series] variables1(ti,g)
dec rec[series] vari_count1(ti,ng)
*

DEC VECT[vec] SMALLX(ti)
DEC VECT[RECT] BIGX(TI)

** next if loop is needed for no interdep/interdep
*
make X
# usinf{medlag to maxlag} usinfr{medlag to maxlag} useg{medlag to maxlag} usgdpg{medlag to maxlag} $
  jpinf{medlag to maxlag} jpinfr{medlag to maxlag} jpeg{medlag to maxlag} jpgdpg{medlag to maxlag}$
  geinf{medlag to maxlag} geinfr{medlag to maxlag} geeg{medlag to maxlag} gegdpg{medlag to maxlag}  $
  ukinf{medlag to maxlag} ukinfr{medlag to maxlag} ukeg{medlag to maxlag} ukgdpg{medlag to maxlag}   $
  frinf{medlag to maxlag} frinfr{medlag to maxlag} freg{medlag to maxlag} frgdpg{medlag to maxlag}   $
  itinf{medlag to maxlag} itinfr{medlag to maxlag} iteg{medlag to maxlag} itgdpg{medlag to maxlag}    $
  cainf{medlag to maxlag} cainfr{medlag to maxlag} caeg{medlag to maxlag} cagdpg{medlag to maxlag}     $
  constant

compu ti = %rows(x)  ;* number of usable observations
comp k = %cols(x)  ;* n. of variables for each equation

** the (1 x k) vector containing lagged endogenous and exog. var.

DO T = 1,TI
DIM SMALLX(T)(K)
END DO T

DO T = 1,TI
  DO J = 1,K
   COMPUTE SMALLX(T)(J)=x(T,J)
  END DO J
END DO T
*
** setting  the matrix  X(t-s)
*
do t = 1,ti
compute s_t(t) = 1.+s_e*%dot(smallx(t),smallx(t))
end

DO T = 1,T
DIM BIGX(T)(N*G,N*G*K)
COMPUTE BIGX(T) = %KRONEKER(%IDENTITY(N*G),TR(SMALLX(T)))
END DO T


** the vector of endogenous variables

*disp ti k

DEC VECT[VECT] SMALLY(TI)
do t= 1,TI
overlay y(1,t) with SMALLY(t)(N*G)
end do t

* setting up the var as a system of indices (to trasform matrices post-multiply by X)

*  matrix for lambda

dec rec xsi_11(k,dim_lam) xsi_1(n*g*k,dim_lam)
compute xsi_1 = %const(.0), xsi_11 = %const(.0)

*
dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec e_p1(p1)
do ll = 1,p1
compute e_p1(ll) = ll**(-0.5)
end

dec vec e_d(d1) e_ng(n*g) e_ngp(n*g*p+d1*p1) xsi11(k) xsi1_1(n*g*k)
compute e_ng = %const(1.), e_d = %const(1.)


if dim_lam==1
{
compute xsi11(k) = 1.

comp engp = %kroneker(e_ng,e_p)
comp edp = %kroneker(e_d,e_p1)

do j = 1,n*g*p
comp e_ngp(j) = engp(j,1)
end

do j = 1,d1*p1
comp e_ngp(n*g*p+j) = edp(j,1)
end

do j = 1,n*g*p+d1*p1
compute xsi11(j) = e_ngp(j)
end

comp xsi1_1 = %kroneker(e_ng,xsi11)

do j = 1,N*g*k
compute xsi_1(j,1) = xsi1_1(j)
end

}
*
* this Europe vs rest of the world
*

if dim_lam==2
{
do j = 1,d1*p1
comp xsi_11(n*g*p+j,1) = xsi_11(n*g*p+j,2) = e_p1(j)
end

comp xsi_11(k,1) = xsi_11(k,2) = 1.

do j = 1,g
do ll = 1,p
comp xsi_11((j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(3*g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(6*g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(2*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(4*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(5*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end


do j = 1,g
do jj = 1,k
comp xsi_1((j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(2*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(3*g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(4*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(5*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(6*g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

}
end if

* the matrix for rho
dec rec xsi2(g*k,g) xsi_2(n*g*k,g)
comp xsi2 = %const(.0), xsi_2 = %const(.0)

dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec[vec] a_xsi2(g)
do i = 1,g
dim a_xsi2(i)(k)
comp a_xsi2(i) = %const(.0)
do j = 1,d1*p1
comp a_xsi2(i)(n*g*p+j) = e_p1(j)
end
comp a_xsi2(i)(k) = 1.
end

do j = 1,g
do i = 1,n
do ll = 1,p
comp a_xsi2(j)((j-1)*p+(i-1)*g*p+ll) = e_p(ll)
end
end
end

do j = 1,g
do i = 1,k
comp xsi2((j-1)*k+i,j) = a_xsi2(j)(i)
end
end

dec vec e_n(n)
compute e_n = %const(1.)

comp xsi_2 = %kroneker(e_n,xsi2)

* the matrix for alfa

dec rec xsi_3(n*g*k,n)
comp xsi_3 = %const(.0)

dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec e_g(g) e_pg(p*g)
compute e_g = %const(1.)

comp e_pg = %kroneker(e_g,e_p)

dec vec[vec] a_xsi3(n)
do i = 1,n
dim a_xsi3(i)(k)
comp a_xsi3(i) = %const(.0)
do j = 1,d1*p1
comp a_xsi3(i)(n*g*p+j) = e_p1(j)
end
comp a_xsi3(i)(k) = 1.
end

do i = 1,n
do j = 1,g*p
comp a_xsi3(i)((i-1)*g*p+j) = e_pg(j)
end
end

dec vec[vec] a_a_xsi3(n)
do i = 1,n
dim a_a_xsi3(i)(g*k)
comp a_a_xsi3(i) = %kroneker(e_g,a_xsi3(i))
end

do i = 1,n
do j = 1,g*k
comp xsi_3((i-1)*g*k+j,i) = a_a_xsi3(i)(j)
end
end

* setting up regressors

DEC VECT[RECT] BIG_W(TI) BIG_Z(TI) BIG_A(TI)

DO T = 1,ti
DIM BIG_W(T)(N*G,dim_lam) BIG_Z(T)(N*G,G) BIG_A(T)(N*G,N)
comp big_w(t) = bigx(t)*xsi_1
comp big_z(t) = bigx(t)*xsi_2
comp big_a(t) = bigx(t)*xsi_3
end

*  the Matrix m_1=[xsi_1, xsi_2, xsi_3]
*
dec rect m_1(n*g*k,n+g+dim_lam)
comp m_1 = %const(.0)

do i = 1,n*g*k
do lam = 1,dim_lam
compute m_1(i,lam) =xsi_1(i,lam)
end do lam
end do i

do i = 1,ng*k
do j = dim_lam+1,g+dim_lam
compute m_1(i,j) = xsi_2(i,j-dim_lam)
end do j
end do i

do i = 1,ng*k
do ii = g+dim_lam+1,dim_lam+g+n
compute m_1(i,ii) = xsi_3(i,ii-g-dim_lam)
end do ii
end do i
*
dec vect[rect] X_M(ti)

DO T = 1,ti
DIM x_m(T)(N*G,dim_lam+g+n)
comp X_M(t) = %const(.0)

do i = 1,n*g
do lam = 1,dim_lam
compute X_M(t)(i,lam) =big_w(t)(i,lam)
end
end do i

do i = 1,ng
do j = dim_lam+1,g+dim_lam
compute X_M(t)(i,j) = big_z(t)(i,j-dim_lam)
end do j
end do i

do i = 1,ng
do ii = g+dim_lam+1,dim_lam+g+n
compute X_M(t)(i,ii) = big_a(t)(i,ii-g-dim_lam)
end do i
end do i

end do t

***********************************************************************
* estimation of the indexes using sequential ols (on  training sample)
* use the estimation to initialize MCMC
************************************************************************
*
dec vect[vect] lambda(ti) rho(ti) alfa_1(ti)

*
do t = 1,ti
dim lambda(t)(dim_lam) rho(t)(g) alfa_1(t)(n)
compute lambda(t) = inv(tr(big_w(t))*big_w(t))*tr(big_w(t))*smally(t)
compute eps1 = smally(t)-big_w(t)*lambda(t)
compute rho(t) = inv(tr(big_z(t))*big_z(t))*tr(big_z(t))*eps1
compute eps2 = eps1-big_z(t)*rho(t)
compute alfa_1(t) = inv(tr(big_a(t))*big_a(t))*tr(big_a(t))*eps2
end do t

*
comp t1 = ti
*
dec vect[vect] theta_ka(t1) theta_mc(t1)

do t = 1,t1

DIM theta_ka(t)(k_1)
dim theta_mc(t)(k_1)

COMPUTE THETA_KA(T) = %const(.0), THETA_MC(T) = %CONST(.0)

do la = 1,dim_lam
compute theta_ka(t)(la) = lambda(t)(la)
compute theta_mc(t)(la) = lambda(t)(la)
end

do j = 1,g
COMPUTE theta_ka(t)(j+dim_lam) = rho(t)(j)
compute theta_mc(t)(j+dim_lam) = rho(t)(j)
end do j

do i = 1,n
COMPUTE theta_ka(t)(g+dim_lam+i) = alfa_1(t)(i)
compute theta_mc(t)(g+dim_lam+i) = alfa_1(t)(i)
end do j

end do t
*

***************************************************
* setting up matrices needed in the gibbs sampling *
****************************************************
dec vect[vect] u2(ti)

dec rect part5(n*g,n*g)
dec real part6 part7 part8 part9

compute def1 = t1+w_0
dec symm ss0hatinv(n*g,n*g)
*
* prepare matrices for leading indicators
*
dec rec[vec] lamdraw(ti,ndraws)
dec rec[vec] rhodraw(ti,ndraws)
dec rec[vec] alfadraw(ti,ndraws)
dec vec phi1dra(ndraws) phi2dra(ndraws) phi3dra(ndraws)

dec vect[symm] omega_ka(t1) omega_mc(t1)
dec vect[rect] emme_mc(t1)

do t = 1,t1
 dim omega_ka(t)(k_1,k_1) omega_mc(t)(k_1,k_1)
 dim emme_mc(t)(k_1,k_1)
 compute omega_ka(t)=%const(0.0), omega_mc(t)=%const(0.0)
 compute emme_mc(t)=%const(0.0)
end do t

dec vec loglike_dr(ndraws)
dec vec[symm] omega_dra(ndraws)


***************************************************
** BEGINNING THE MCMC ROUTINE
***************************************************
*
comp hetero = %const(1.)

do draws = 1,ndraws
 disp draws

 do t = 1,ti
 dim lamdraw(t,draws)(dim_lam)
 dim rhodraw(t,draws)(g)
 dim alfadraw(t,draws)(n)
 dim u2(t)(k_1)
 end do t

* do draws1 = 1,ndraws1
*disp draws draws1
*
** kalman filter
*
 compute omega_ka(1) = %IDENTITY(K_1)
 compute omegaTT_1 = omega_ka(1)+big_phi
 compute emme_mc(1) = omega_ka(1)*inv(omegaTT_1)
 compute omega_mc(1) = omega_ka(1)-%mqform(omegaTT_1,tr(emme_mc(1)))
 comp u2(1) = %ran(1.)
 comp loglike_kf = 0.0

 do t = 2,t1
  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute omegaTT_1 = omega_ka(t-1)+delta_t*big_phi
  compute effeTT_1 = X_M(t)*omegaTT_1*tr(X_M(t))+(1./hetero(t))*inv(omega)
  compute kappaTT_1 = omegaTT_1*tr(X_M(t))*inv(effeTT_1)
  compute imenoka = %identity(k_1)-kappaTT_1*X_M(t)
  compute omega_ka(t) = imenoka*omegaTT_1

  compute resi = smally(t)-X_M(t)*theta_ka(t-1)
  compute theta_ka(t) = theta_ka(t-1)+kappaTT_1*resi
  compute delta_t1 = arch4**(t+1)+arch3*(1./(1.-arch4))*(1.-arch4**(t+1))
  compute omegaTT_11 = omega_ka(t)+delta_t1*big_phi
  compute emme_mc(t) = omega_ka(t)*inv(omegaTT_11)
  compute omega_mc(t)= omega_ka(t)-%mqform(omegaTT_11,tr(emme_mc(t)))

  compute resi1 = smally(t)-X_M(t)*theta_ka(t)
  comp loglike_temp = -0.5*n*g*log(2.*%pi)-0.5*log(%det(effeTT_1))-0.5*%qform(inv(effeTT_1),resi1)
  comp loglike_kf = loglike_kf+loglike_temp
  release resi resi1 omegaTT_1 effeTT_1 kappaTT_1 imenoka omegatt_11
  comp u2(t) = %ran(1.)

 end do t

 comp loglike_dr(draws) = loglike_kf

do draws1 = 1,ndraws1

*DISP DRAWS DRAWS1
 comp u2(t1) = %ran(1.)
 compute theta_mc(t1) = theta_ka(t1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,DIM_LAM
 compute lambda(t1)(sp) = theta_mc(t1)(sp)
 end do sp

 do sp = dim_lam+1,g+dim_lam
 compute rho(t1)(sp-dim_lam) = theta_mc(t1)(sp)
 end do sp

 do sp = g+dim_lam+1,k_1
 compute alfa_1(t1)(sp-g-dim_lam) = theta_mc(t1)(sp)
 end do sp

 do t = 2,t1
 comp u2(t1-t+1) = %ran(1.)
  compute themean=theta_ka(t1-t+1)+emme_mc(t1-t+1)* $
	       (theta_mc(t1-t+2)-theta_ka(t1-t+1))
  compute theta_mc(t1-t+1) = themean+%decomp(omega_mc(t1-t+1))*u2(t1-t+1)
  compute themean = %const(.0)

* compute theta_mc(t1-t+1) = theta_ka(t1-t+1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,dim_lam
  compute lambda(t1-t+1)(sp) = theta_mc(t1-t+1)(sp)
  end do sp

  do sp = dim_lam+1,g+dim_lam
  compute rho(t1-t+1)(sp-dim_lam) = theta_mc(t1-t+1)(sp)
  end do sp

  do sp = g+dim_lam+1,k_1
  compute alfa_1(t1-t+1)(sp-g-dim_lam) = theta_mc(t1-t+1)(sp)
 end do sp


 end do t

* compute theta_ka(1) = theta_mc(1)

 compute part5 = %const(.0)
 compute part6 = .0
 compute part7 = .0, part8 = .0, part9 = 0.0

 comp sum_sig = 0.0, sum_eome = 0.0

 DO T = 2,t1

  compute eps1 = smally(t)-big_w(t)*lambda(t)-big_z(t)*rho(t)-big_a(t)*alfa_1(t)
  comp eps_eps = eps1*tr(eps1)
  comp part6 = zeta*s_t(t)+%qform(omega,eps1)
*  compute eps1 = %const(.0)
  compute p00 = 2./(part6)

  if exact ==0
  {
  compute hetero(t) = p00*%rangamma(.5*(ng+zeta))
  }
  if exact ==1
  {
  compute hetero(t) = 1.0
  }

  compute part5 = part5+(hetero(t))*eps_eps
  compute sum_sig = sum_sig+log(1./hetero(t))
  comp sum_eome = sum_eome +(hetero(t))*%qform(omega,eps1)

  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute resth = (1./delta_t)*(theta_mc(t)-theta_mc(t-1))
  compute resth1 = (1./delta_t)*(lambda(t)-lambda(t-1))
  compute resth2 = (1./delta_t)*(rho(t)-rho(t-1))
  compute resth3 = (1./delta_t)*(alfa_1(t)-alfa_1(t-1))

  compute part7 = part7+%dot(resth1,resth1)
  compute part8 = part8+%dot(resth2,resth2)
  compute part9 = part9+%dot(resth3,resth3)


end do t

 compute seps1 = part7+d_0
 compute p11= 2./(seps1)
 compute phi1 = p11*%rangamma(.5*(t1+v_0))
 compute phi_1 = %mscalar(1./phi1)

 compute seps2 = part8+d_0
 compute p2= 2./(seps2)
 compute phi2 = p2*%rangamma(.5*(t1*g+v_0))
 compute phi_2 = %mscalar(1./phi2)

 compute seps3 = part9+d_0
 compute p3= 2./(seps3)
 compute phi3 = p3*%rangamma(.5*(t1*n+v_0))
 compute phi_3 = %mscalar(1./phi3)

 comp big_phi = %const(.0)

 do i = 1,dim_lam
 comp big_phi(i,i) = phi_1(i,i)
 end do lam

 do i = 1,g
 comp big_phi(i+dim_lam,i+dim_lam) = phi_2(i,i)
 end

 do i = 1,n
 comp big_phi(i+g+dim_lam,i+g+dim_lam) = phi_3(i,i)
 end

 comp big_phiinv = inv(big_phi)

 compute werre_0 = w_0*sigma_eps
 compute ss0hatinv = werre_0+part5
 compute Swish = tr(%decomp(inv(ss0hatinv)))
 compute omega = %mqform(%RANWISHART(N*g,def1),Swish)

 end do draws1

 comp omega_dra(draws) = omega
 compute phi1dra(draws) = 1./phi1
 compute phi2dra(draws) = 1./phi2
 compute phi3dra(draws) = 1./phi3

 do t = 2,ti
 compute lamdraw(t,draws) = lambda(t)
 compute rhodraw(t,draws) = rho(t)
 compute alfadraw(t,draws) = alfa_1(t)
 end do t

end do draws

******************************************
****** END OF MCMC ROUTINE ***************
*****************************************
*
***********************************************************
** uncertainty coming from the MCMC
comp nvar = ng
smpl beg tempend
dec vec[vec] theta_all(ndraws) delta_all(ndraws)

do draws = 1,ndraws
 dim theta_all(draws)(k_1)
 dim delta_all(draws)(n*g*k)

  do sp = 1,dim_lam
   compute theta_all(draws)(sp) = lamdraw(t1,draws)(sp)
  end

  do sp = dim_lam+1,dim_lam+g
   compute theta_all(draws)(sp) = rhodraw(t1,draws)(sp-dim_lam)
  end

  do sp = g+dim_lam+1,k_1
   compute theta_all(draws)(sp) = alfadraw(t1,draws)(sp-g-dim_lam)
  end

 comp delta_all(draws) = m_1*theta_all(draws)
end
*

system(model=varmodel1) 1 to nvar
variables  usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg
lags 1 to nlags
det constant
end(system)

*
declare vect[rect] responses(ndraws)
declare rect[series] impulses(nvar,nvar)
dec rec betadraw(k,ng)

infobox(action=define,progress,lower=1,upper=ndraws) 'impulse responses'
do draws = 1,ndraws

 do j = 1,ng
* comp delta_all(draws)((j-1)*(k+nlags)+1) = 0.6
 do i = 1,k
 compute betadraw(i,j) = delta_all(draws)((j-1)*k+i)
 end
 end

 compute %modelsetcoeffs(varmodel1,(betadraw))
*
 ** compute block-choleski
 comp omega_11 = %xsubmat(inv(omega_dra(draws)),1,g,1,g)
 comp omega_22 = %xsubmat(inv(omega_dra(draws)),1+g,n*g,1+g,n*g)
 comp omega_12 = %xsubmat(inv(omega_dra(draws)),1,g,1+g,n*g)
 comp omega_21 = %xsubmat(inv(omega_dra(draws)),1+g,n*g,1,g)

 comp E_E = omega_22-omega_21*inv(omega_11)*omega_12

 comp eigdec_om = %EIGDECOMP(omega_11)
 comp eigdec_e = %EIGDECOMP(E_E)

 comp lambda_om = %diag(eigdec_om(1))
 comp lambda_e = %diag(eigdec_e(1))

 comp sqrt_om = eigdec_om(2)*%sqrt(lambda_om)*tr(eigdec_om(2))
 comp sqrt_e = eigdec_e(2)*%sqrt(lambda_e)*tr(eigdec_e(2))

 comp fact = omega_21*inv(omega_11)*sqrt_om

 comp chole = %blockglue(|| %BLOCKGLUE(|| sqrt_om , %zeros(g,(n-1)*g) ||) | %blockglue(|| fact, sqrt_e ||) ||)
 ** end compute block-choleski
 *
 ** or simply do choleski
 *comp chole= %decomp(inv(omega_dra(draws)))
 comp sigm = inv(omega_dra(draws))
 @cndition(decomp=chole) varmodel1 nstep tempend+1 sigm 2 condfore
 # usgdpg tempend+1 usgdpg(tempend)+1.
* # usgdpg tempend+2 usgdpg(tempend)+.5
* # usgdpg tempend+3 usgdpg(tempend)+.25
* # usgdpg tempend+4 usgdpg(tempend)
 # useg tempend+1 useg(tempend)+1.
* # useg tempend+2 usgdpg(tempend)+.5
 forecast(model=varmodel1,results=forecasts) nvar nstep tempend+1

 /*
 set prova tempend+1 tempend+nstep = condfore(24)-forecasts(24)
 set prova1 tempend+1 tempend+nstep = condfore(4)-forecasts(4)
 graph(key=below) 2 ;#condfore(24) tempend+1 tempend+nstep ;#forecasts(24) tempend+1 tempend+nstep
 graph(key=below) 2 ;#prova1 tempend+1 tempend+nstep ;#prova tempend+1 tempend+nstep
 */

*     Store the impulse responses as difference between conditional and unconditional forecast
 dim responses(draws)(nvar,nstep)
 do i = 1,nvar
  do j = 1,nstep
   comp responses(draws)(i,j)=condfore(i)(tempend+j)-forecasts(i)(tempend+j)
  end
 end

 infobox(current=draws)
end do draws
infobox(action=remove)


** compute here IRF and bands for each variable
** 4 = US gdp; 8 = JP gdp; 12 = DE gdp ; 16 = UK; 20 = FR gdp; 24 = IT gdp; 28 = CA gdp

dec vect[series] upper(nvar) lower(nvar) resp(nvar)
comp j = 16
do j = 1,nvar
   smpl 1 ndraws
   compute minlower=maxupper=0.0
      clear lower(j) upper(j) resp(j)
      do i=1,nstep
         set work 1 ndraws = responses(t)(j,i)
         compute frac=%fractiles(work,||.05,0.5,.95||)
         compute lower(j)(i)=frac(1)
         compute upper(j)(i)=frac(3)
         compute resp(j)(i)=frac(2)
      end do i
      compute maxupper=%max(maxupper,%maxvalue(upper(j)))
      compute minlower=%min(minlower,%minvalue(lower(j)))
/*
   smpl 1 nstep
      graph(ticks,min=minlower,max=maxupper,number=0) 3 j i
      # resp(j)
      # upper(j) / 2
      # lower(j) / 2
*/
end

/*
do j = 4,28,4
print / resp(j) upper(j) lower(j)
end

*smpl 1 nstep
graph 2
# resp(4)
# resp(8)
# resp(12)
# resp(16)
# resp(20)
# resp(24)
# resp(28)
*/

COMP MINLOWER = -.5, MAXUPPER = 1.
smpl 1 nstep
spgraph(hfields=3,vfields=3,header='Responses of GDP growth to a shock to real US variables ')
      graph(ticks,min=minlower,max=maxupper,number=0,header='US') 3 2 1
      # resp(4)
      # upper(4) / 2
      # lower(4) / 2
      graph(ticks,min=minlower,max=maxupper,number=0,header='Japan') 3 1 2
      # resp(8)
      # upper(8) / 2
      # lower(8) / 2
      graph(ticks,min=minlower,max=maxupper,number=0,header='Germany') 3 1 3
      # resp(12)
      # upper(12) / 2
      # lower(12) / 2
      graph(ticks,min=minlower,max=maxupper,number=0,header='UK') 3 2 2
      # resp(16)
      # upper(16) / 2
      # lower(16) / 2
      graph(ticks,min=minlower,max=maxupper,number=0,header='France') 3 2 3
      # resp(20)
      # upper(20) / 2
      # lower(20) / 2
      graph(ticks,min=minlower,max=maxupper,number=0,header='Canada') 3 3 2
      # resp(28)
      # upper(28) / 2
      # lower(28) / 2
      graph(ticks,min=minlower,max=maxupper,number=0,header='Italy') 3 3 3
      # resp(24)
      # upper(24) / 2
      # lower(24) / 2
spgraph(done)
*
open copy irf_2ndrevision.xls
copy(for=xls,org=obs,dates) / resp(4) upper(4) lower(4) resp(8) upper(8) lower(8) resp(12) upper(12) lower(12) $
      resp(16) upper(16) lower(16) resp(20) upper(20) lower(20) resp(28) upper(28) lower(28) resp(24) upper(24) lower(24)
close copy
*

