* name: dating-index.prg; february 2003; M.Ciccarelli and F. Canova, RATS version 6.0
* this version 11 december 2007; Rats version 6.2

* Version with 3 indices, all time varying. M5 model with exact factorization and no variable effect
* Changes in the parameter alter0 are needed to have 1, 4 and 8 steps ahead
* Parameter dim_lam must be changed to have 1 or 2 common factors
* Benchmark is with exact factorization, dim_lam = 2, 1 steps ahead
* This version does not compute impulse responses.
*
*
* Model is
*
* Y(t) = X(t-s)*b(t) + e(t),  with e_t ~N(0,sigma(e))
* X(t) contains lagged Y (from lag medlag to lag maxlag)
* and exogenous variables (from lag medlag to lag lag_exo)
*
* the index structure in coefficients is
* b(t) = xsi_1*lambda(t)+xsi_2*rho(t)+xsi_3*alfa(t)+u(t)
*      = M_1*theta(t)+u(t), with  u(t)~N(0,%kroneker(sigma(e),V)
* where M_1 = [xsi_1 xsi_2 xsi_3]; theta(t) = (lambda(t),rho'(t),alfa'(t))'
*
* the model is rewritten as:
* Y(t) = [X(t-s)*M_1]*theta(t) + v(t),  with v_t ~N(0,sigma_t* Omega)

* We Assume:
* theta(t) = theta(t-1)+eta(t),  with eta(t)~N(0,B2(t))
* B2(t) = arch3* B2(t-1)+ arch4* B2(0)
*
* Moreover:
* sigma_t ~ G(zeta,zeta*s_t), where s_t = (1+sigma^2*X'X)
* Omega= inv(sigma(e)) ~ W(w_0, Q_0);
* V= sigma^2*I_k; sigma^2 estimated from data or [p(sigma^2) \propto (sigma^2)^{-1};]

* B2(0) =diag[phi_1, phi_2, phi_3]; phi_1=scala1; phi_2=scala2*I_g; phi_3=scala3*I_n
* the prior on phi_1, phi_2 and phi_3 is IG(v_0/2, d_0/2)

* [in version base10tv_dif the prior for phi_2 and phi_3 is diffuse, i.e
* p(phi_2) \propto (phi_2)^{-0.5*(g+1)}; p(phi_3) \propropphi_3)^{-0.5*(n+1)} ]
*
* Here arch3; arch4; w_0; scala1; scala2; scala3; zeta are parameters set a priori.
* sigma^2, Q_0 are estimated from the data.
*
*** alternatives: 1) send sigma^2 --->0 (decomposition in indices exact)
*                 2) number of components in lambda (=1 or = 2)
*                 3) non informative B2(0)
*                 4) prior on v_t diffuse (send zeta ---> 0 )

** choose seeds here. bch is seeds = 10. to replicate table 1 choose sequentially seeds = 1, 2, 3,...,9 and average results
comp seeds = 10
seed seeds

cal 1980 1 4
all 14 2001:4
eqv 1 to 14
usinf jpinf geinf ukinf frinf itinf cainf
usgdpg jpgdpg gegdpg ukgdpg frgdpg itgdpg cagdpg

compute beg=1980:1
compute tempend=1990:4
compute end=2000:4     ;* 1995:4
compute dat=tempend-beg
compute obs=end-beg
smpl beg end
*
*
********** switching parameters
compute inter = 2  ;* = 1 no interdipendence; = 2 with interdipendences
compute alter0 = 1 ;* =1 one step ahead; =4 four steps ahead; =8 eight steps ahead.
compute alter1=1   ;* =1 estimate sigma^2 from the data; =0 set sigma^2 =0.0001
compute dim_lam = 2 ;* change here = 1/2 if lambda has got 1/2 components
compute zeta = .00 ;* set to zero for a noninformative prior on sigma_t
*
*************** initialization
compute n = 7
compute g = 4
comput ng= n*g
compute minlag = 0
if alter0==1
{
compute medlag = 1
compute maxlag = 1
compute lag_exo =1
}
if alter0==4
{
compute medlag = 4
compute maxlag = 8
compute lag_exo = 5
}
if alter0==8
{
compute medlag = 8
compute maxlag = 12
compute lag_exo = 9
}
end if

compute nlags=p=maxlag-medlag+1 ;* n. of lags of endogenous variables
compute p1 = lag_exo-medlag+1   ;* n. of lags of exogenous variables
comp nlags1 = 3                 ;* number of lags used in the preliminary estimation
compute d1 = 1                  ;* n. of exogenous variables
compute d = d1*p1+1             ;* exog. var times lags plus the constant
compute k1 = n*g*p+d            ;* n. of variable in each equation
compute ndraws = 5000           ;* number of draws in MCMC
compute ndraws1 = 600            ;* n. of times we repeat the MCMC
compute mindraws = 4000
compute begdraws= ndraws-mindraws ;* throw away some draws in the last iteration
*disp k1;				   * to compute moments of indices.
comp k_1 = n+dim_lam              ;* dimension of B2(0) matrix
*
************* parameter values
compute scala1=0.5
compute scala2=0.5
compute arch3 = 1.0  ;* paramet
compute arch4= 0.0   ;* for no heteroscedastic variance set arch4 = 0.0
compute w_0=n*g+50    ;* degrees of freedom for prior of var-cov matrix
compute v_0 = 10., d_0 = 1.0  ;* shape and scale for fi1,2,3. set to zero for a non informative prior
*
***********  data
*
open data indexsa.xls
data(org=obs,for=xls) /
close data

* Eliminate outliers for germany at unification, otherwise get
* a huge spike in the indices at that time.
*
statistics(noprint) gegdpg beg 1990:4
compute a1=%mean
statistics(noprint) gegdpg 1992:1 2000:4
compute a2=%mean
statistics(noprint) geeg beg 1990:4
compute a3=%mean
statistics(noprint) geeg 1992:1 2000:4
compute a4=%mean
set gegdpg 1991:1 1991:2 = a1
set gegdpg 1991:3 1991:4 = a2
set geeg 1991:1 1991:2 =a3
set geeg 1991:3 1991:4 =a4
*
** standardise variables
*
dofor i = usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg cpg
stat(noprint) ([series] i)
set ([series] i) = (([series] i)-%mean)/sqrt(%variance)
end dofor

* estimating sigma^2 and Q_0
*
*************** Q_0 is sigma_eps and omega is also initialized as Q_0
*
system 1 to n*g
variables  usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg
lags 1 to 1
det cpg{0 to 1} constant
end(system)
estimate(noprint,noftest,outsigma=sigma_eps) beg end
dec symm omega(ng,ng)
compute omega = inv(sigma_eps)

************* sigma^2
compute s_e = 0.0
*
if alter1==1
{
dofor i = usinf usinfr useg usgdpg jpinf jpinfr jpeg jpgdpg $
  geinf geinfr geeg gegdpg ukinf ukinfr ukeg ukgdpg $
  frinf frinfr freg frgdpg itinf itinfr iteg itgdpg $
  cainf cainfr caeg cagdpg
linreg(noprint) i
# constant i{1 to nlags1}
compute s_e = s_e+(1./(n*g))*(sqrt(%seesq))
end dofor
}
if alter1==0
compute s_e = 0.0001
end if
*
************ setting up B2(0)

comp k_1 = n+dim_lam

dec symm big_phi(k_1,k_1) big_phiinv(k_1,k_1)
comp big_phi = %const(.0)

dec symm phi_1(dim_lam,dim_lam)
comp phi_1 = %mscalar(scala1)
compu phi_1inv = inv(phi_1)

dec symm phi_3(n,n) phi_3inv(n,n)
compute phi_3 = %mscalar(scala2)
comp phi_3inv = inv(phi_3)

do i = 1,dim_lam
comp big_phi(i,i) = phi_1(i,i)
end

do i = 1,n
comp big_phi(i+dim_lam,i+dim_lam) = phi_3(i,i)
end

comp big_phiinv = inv(big_phi)
*wri big_phiinv

* setting up various matrices for preliminary OLS estimation to initialize indices
* and for use in the MCMC
*
smpl(reglist)
# usinf{minlag to maxlag} usinfr{minlag to maxlag} useg{minlag to maxlag} usgdpg{minlag to maxlag} $
  jpinf{minlag to maxlag} jpinfr{minlag to maxlag} jpeg{minlag to maxlag} jpgdpg{minlag to maxlag}$
  geinf{minlag to maxlag} geinfr{minlag to maxlag} geeg{minlag to maxlag} gegdpg{minlag to maxlag}  $
  ukinf{minlag to maxlag} ukinfr{minlag to maxlag} ukeg{minlag to maxlag} ukgdpg{minlag to maxlag}   $
  frinf{minlag to maxlag} frinfr{minlag to maxlag} freg{minlag to maxlag} frgdpg{minlag to maxlag}   $
  itinf{minlag to maxlag} itinfr{minlag to maxlag} iteg{minlag to maxlag} itgdpg{minlag to maxlag}    $
  cainf{minlag to maxlag} cainfr{minlag to maxlag} caeg{minlag to maxlag} cagdpg{minlag to maxlag}     $
  cpg{minlag to lag_exo} constant

MAKE(transpose) Y
# usinf usinfr useg usgdpg $
  jpinf jpinfr jpeg jpgdpg geinf geinfr geeg gegdpg $
  ukinf ukinfr ukeg ukgdpg frinf frinfr freg frgdpg $
  itinf itinfr iteg itgdpg cainf cainfr caeg cagdpg


comp ti = %cols(y)

DEC VEC[REC] XX(N+1)
dec vec hetero_old(ti)
dec vec hetero_can(ti)
dec vec hetero(ti)
dec rec hetero_dra(ti,ndraws)

comp hetero = %const(s_e)
dec vec s_t(ti)
dec vec[vec] ss_t(i)
*

DEC VECT[vec] SMALLX(ti)
DEC VECT[RECT] BIGX(TI)

** next if loop is needed for no interdep/interdep
*
if inter==1
{
make XX(1)
# usinf{medlag to maxlag} usinfr{medlag to maxlag} useg{medlag to maxlag} usgdpg{medlag to maxlag}
make XX(2)
# jpinf{medlag to maxlag} jpinfr{medlag to maxlag} jpeg{medlag to maxlag} jpgdpg{medlag to maxlag}
make XX(3)
#  geinf{medlag to maxlag} geinfr{medlag to maxlag} geeg{medlag to maxlag} gegdpg{medlag to maxlag}
make XX(4)
#  ukinf{medlag to maxlag} ukinfr{medlag to maxlag} ukeg{medlag to maxlag} ukgdpg{medlag to maxlag}
make XX(5)
#  frinf{medlag to maxlag} frinfr{medlag to maxlag} freg{medlag to maxlag} frgdpg{medlag to maxlag}
make XX(6)
#  itinf{medlag to maxlag} itinfr{medlag to maxlag} iteg{medlag to maxlag} itgdpg{medlag to maxlag}
make XX(7)
#  cainf{medlag to maxlag} cainfr{medlag to maxlag} caeg{medlag to maxlag} cagdpg{medlag to maxlag}
make XX(8)
#  cpg{minlag to lag_exo} constant

compu ti = %rows(Xx(1))  ;* number of usable observations
comp k = %cols(xx(1))+%cols(xx(8))  ;* n. of variables for each equation

DO T = 1,TI
DIM SMALLX(T)(K)
DIM BIGX(T)(N*G,N*G*K)
compute smallx(t) = %const(.0)
compute bigx(t) = %const(.0)
END DO T

comp s_t = %const(.0)
do i = 1,n
dim ss_t(i)(ti)
comp ss_t(i) = %const(.0)
end

do i = 1,n

dim ss_t(i)(ti)
comp ss_t(i) = %const(.0)

DO T = 1,TI

  DO J = 1,%cols(xx(i))
   COMPUTE SMALLX(T)(J)=Xx(I)(T,J)
  END DO J

  DO J = 1,D
   COMPUTE SMALLX(T)(%cols(xx(i))+J)=xx(N+1)(T,J)
  END DO J

compute ss_t(i)(t) = 1.+s_e*%dot(smallx(t),smallx(t))

compute krone = %kroneker(%identity(g),tr(smallx(t)))

do kkk = 1,g*k
do j = 1,g
COMPUTE BIGX(T)((i-1)*g+j,(i-1)*g*k+kkk) = krone(j,kkk)
end do j
end do k

END DO T

end do i

do i = 1,n
compute s_t = s_t + (1./n)*ss_t(i)
end
}
if inter==2
{
make X
# usinf{medlag to maxlag} usinfr{medlag to maxlag} useg{medlag to maxlag} usgdpg{medlag to maxlag} $
  jpinf{medlag to maxlag} jpinfr{medlag to maxlag} jpeg{medlag to maxlag} jpgdpg{medlag to maxlag}$
  geinf{medlag to maxlag} geinfr{medlag to maxlag} geeg{medlag to maxlag} gegdpg{medlag to maxlag}  $
  ukinf{medlag to maxlag} ukinfr{medlag to maxlag} ukeg{medlag to maxlag} ukgdpg{medlag to maxlag}   $
  frinf{medlag to maxlag} frinfr{medlag to maxlag} freg{medlag to maxlag} frgdpg{medlag to maxlag}   $
  itinf{medlag to maxlag} itinfr{medlag to maxlag} iteg{medlag to maxlag} itgdpg{medlag to maxlag}    $
  cainf{medlag to maxlag} cainfr{medlag to maxlag} caeg{medlag to maxlag} cagdpg{medlag to maxlag}     $
  cpg{minlag to lag_exo} constant


compu ti = %rows(x)  ;* number of usable observations
comp k = %cols(x)  ;* n. of variables for each equation

** the (1 x k) vector containing lagged endogenous and exog. var.

DO T = 1,TI
DIM SMALLX(T)(K)
END DO T

DO T = 1,TI
  DO J = 1,K
   COMPUTE SMALLX(T)(J)=x(T,J)
  END DO J
END DO T
*
** setting  the matrix  X(t-s)
*
do t = 1,ti
compute s_t(t) = 1.+s_e*%dot(smallx(t),smallx(t))
end

DO T = 1,T
DIM BIGX(T)(N*G,N*G*K)
COMPUTE BIGX(T) = %KRONEKER(%IDENTITY(N*G),TR(SMALLX(T)))
END DO T
}
end if

** the vector of endogenous variables

*disp ti k

DEC VECT[VECT] SMALLY(TI)
do t= 1,TI
overlay y(1,t) with SMALLY(t)(N*G)
end do t

* setting up the var as a system of indices (to trasform matrices post-multiply by X)

*  matrix for lambda

dec rec xsi_11(k,dim_lam) xsi_1(n*g*k,dim_lam)
compute xsi_1 = %const(.0), xsi_11 = %const(.0)

*
dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec e_p1(p1)
do ll = 1,p1
compute e_p1(ll) = ll**(-0.5)
end

dec vec e_d(d1) e_ng(n*g) e_ngp(n*g*p+d1*p1) xsi11(k) xsi1_1(n*g*k)
compute e_ng = %const(1.), e_d = %const(1.)


if dim_lam==1
{
compute xsi11(k) = 1.

comp engp = %kroneker(e_ng,e_p)
comp edp = %kroneker(e_d,e_p1)

do j = 1,n*g*p
comp e_ngp(j) = engp(j,1)
end

do j = 1,d1*p1
comp e_ngp(n*g*p+j) = edp(j,1)
end

do j = 1,n*g*p+d1*p1
compute xsi11(j) = e_ngp(j)
end

comp xsi1_1 = %kroneker(e_ng,xsi11)

do j = 1,N*g*k
compute xsi_1(j,1) = xsi1_1(j)
end

}
*
* this Europe vs rest of the world
*

if dim_lam==2
{
do j = 1,d1*p1
comp xsi_11(n*g*p+j,1) = xsi_11(n*g*p+j,2) = e_p1(j)
end

comp xsi_11(k,1) = xsi_11(k,2) = 1.

do j = 1,g
do ll = 1,p
comp xsi_11((j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(3*g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(6*g*p+(j-1)*p+ll,1) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(2*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(4*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end

do j = 1,g
do ll = 1,p
comp xsi_11(5*g*p+(j-1)*p+ll,2) = e_p(ll)
end
end


do j = 1,g
do jj = 1,k
comp xsi_1((j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(2*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(3*g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(4*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(5*g*k+(j-1)*k+jj,2) = xsi_11(jj,2)
end
end

do j = 1,g
do jj = 1,k
comp xsi_1(6*g*k+(j-1)*k+jj,1) = xsi_11(jj,1)
end
end

}
end if

* the matrix for alfa

dec rec xsi_3(n*g*k,n)
comp xsi_3 = %const(.0)

dec vec e_p(nlags)
do ll = 1,nlags
compute e_p(ll) = ll**(-0.5)
end

dec vec e_g(g) e_pg(p*g)
compute e_g = %const(1.)

comp e_pg = %kroneker(e_g,e_p)

dec vec[vec] a_xsi3(n)
do i = 1,n
dim a_xsi3(i)(k)
comp a_xsi3(i) = %const(.0)
do j = 1,d1*p1
comp a_xsi3(i)(n*g*p+j) = e_p1(j)
end
comp a_xsi3(i)(k) = 1.
end

do i = 1,n
do j = 1,g*p
comp a_xsi3(i)((i-1)*g*p+j) = e_pg(j)
end
end

dec vec[vec] a_a_xsi3(n)
do i = 1,n
dim a_a_xsi3(i)(g*k)
comp a_a_xsi3(i) = %kroneker(e_g,a_xsi3(i))
end

do i = 1,n
do j = 1,g*k
comp xsi_3((i-1)*g*k+j,i) = a_a_xsi3(i)(j)
end
end


* setting up regressors

DEC VECT[RECT] BIG_W(TI) BIG_A(TI)

DO T = 1,ti
DIM BIG_W(T)(N*G,dim_lam) BIG_A(T)(N*G,N)
comp big_w(t) = bigx(t)*xsi_1
comp big_a(t) = bigx(t)*xsi_3
end
*
*  the Matrix m_1=[xsi_1,  xsi_3]
*
dec rect m_1(n*g*k,n+dim_lam)
comp m_1 = %const(.0)

do i = 1,n*g*k
do lam = 1,dim_lam
compute m_1(i,lam) =xsi_1(i,lam)
end do lam
end do i

do i = 1,ng*k
do j = dim_lam+1,n+dim_lam
compute m_1(i,j) = xsi_3(i,j-dim_lam)
end do j
end do i

*
dec vect[rect] X_M(ti)

DO T = 1,ti
DIM x_m(T)(N*G,dim_lam+n)
comp X_M(t) = %const(.0)

do i = 1,n*g
do lam = 1,dim_lam
compute X_M(t)(i,lam) =big_w(t)(i,lam)
end
end do i

do i = 1,ng
do j = dim_lam+1,n+dim_lam
compute X_M(t)(i,j) = big_a(t)(i,j-dim_lam)
end do j
end do i

end do t

***********************************************************************
* estimation of the indexes using sequential ols (on  training sample)
* use the estimation to initialize MCMC
************************************************************************
*
dec vect[vect] lambda(ti) alfa_1(ti)

*
do t = 1,ti
dim lambda(t)(dim_lam) alfa_1(t)(n)
compute lambda(t) = inv(tr(big_w(t))*big_w(t))*tr(big_w(t))*smally(t)
compute eps1 = smally(t)-big_w(t)*lambda(t)
compute alfa_1(t) = inv(tr(big_a(t))*big_a(t))*tr(big_a(t))*eps1
end do t

*
comp t1 = ti
*
dec vect[vect] theta_ka(t1) theta_mc(t1)

do t = 1,t1

DIM theta_ka(t)(k_1)
dim theta_mc(t)(k_1)

COMPUTE THETA_KA(T) = %const(.0), THETA_MC(T) = %CONST(.0)

do la = 1,dim_lam
compute theta_ka(t)(la) = lambda(t)(la)
compute theta_mc(t)(la) = lambda(t)(la)
end

do i = 1,n
COMPUTE theta_ka(t)(dim_lam+i) = alfa_1(t)(i)
compute theta_mc(t)(dim_lam+i) = alfa_1(t)(i)
end do j

end do t
*

***************************************************
* setting up matrices needed in the gibbs sampling *
****************************************************
dec vect[vect] u2(ti)

dec rect part5(n*g,n*g)
dec real part6 part7 part8 part9

compute def1 = t1+w_0
dec symm ss0hatinv(n*g,n*g)
*


dec rec[vec] lamdraw(ti,ndraws)
dec rec[vec] alfadraw(ti,ndraws)
dec vec phi1dra(ndraws) phi2dra(ndraws) phi3dra(ndraws)

dec vect[symm] omega_ka(t1) omega_mc(t1)
dec vect[rect] emme_mc(t1)

dec sym int_res1(ti-1,n*g) int_res2(ti-1,n*g) int_res3(ti-1,n*g) int_res4(ti-1,n*g)

do t = 1,t1
 dim omega_ka(t)(k_1,k_1) omega_mc(t)(k_1,k_1)
 dim emme_mc(t)(k_1,k_1)
 compute omega_ka(t)=%const(0.0), omega_mc(t)=%const(0.0)
 compute emme_mc(t)=%const(0.0)
end do t

comp hetero = %const(1.)

dec vec loglike_dr(ndraws)
dec vec log_like(ndraws)

dec vec[symm] omega_dra(ndraws)
*
dec vec sigmadra(ndraws*ndraws1)

compute v_0 = 10., d_0 = 1.0  ;* shape and scale sigma_2. set to zero for a non informative prior
compute v1_0 = 10., d1_0 = 1.0  ;* shape and scale sigma_2. set to zero for a non informative prior

***************************************************
** BEGINNING THE MCMC ROUTINE
***************************************************
*
infobox(action=define,progress,lower=1,upper=ndraws) 'Monte Carlo Integration - STEP0'
do draws = 1,ndraws

 do t = 1,ti
 dim lamdraw(t,draws)(dim_lam)
 dim alfadraw(t,draws)(n)
 dim u2(t)(k_1)
 end do t

*
** kalman filter
*
 compute omega_ka(1) = %IDENTITY(K_1)
 compute omegaTT_1 = omega_ka(1)+big_phi
 compute emme_mc(1) = omega_ka(1)*inv(omegaTT_1)
 compute omega_mc(1) = omega_ka(1)-%mqform(omegaTT_1,tr(emme_mc(1)))
 comp u2(1) = %ran(1.)

 comp loglike_kf = 0.0

 do t = 2,t1
  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute omegaTT_1 = omega_ka(t-1)+delta_t*big_phi
  compute effeTT_1 = X_M(t)*omegaTT_1*tr(X_M(t))+(1./hetero(t))*inv(omega)
  compute kappaTT_1 = omegaTT_1*tr(X_M(t))*inv(effeTT_1)
  compute imenoka = %identity(k_1)-kappaTT_1*X_M(t)
  compute omega_ka(t) = imenoka*omegaTT_1

  compute resi = smally(t)-X_M(t)*theta_ka(t-1)
  compute theta_ka(t) = theta_ka(t-1)+kappaTT_1*resi
  compute delta_t1 = arch4**(t+1)+arch3*(1./(1.-arch4))*(1.-arch4**(t+1))
  compute omegaTT_11 = omega_ka(t)+delta_t1*big_phi
  compute emme_mc(t) = omega_ka(t)*inv(omegaTT_11)
  compute omega_mc(t)= omega_ka(t)-%mqform(omegaTT_11,tr(emme_mc(t)))

  compute resi1 = smally(t)-X_M(t)*theta_ka(t)
  comp loglike_temp = -0.5*n*g*log(2.*%pi)-0.5*log(%det(effeTT_1))-0.5*%qform(inv(effeTT_1),resi)
  comp loglike_kf = loglike_kf+loglike_temp
  release resi resi1 omegaTT_1 effeTT_1 kappaTT_1 imenoka omegatt_11
  comp u2(t) = %ran(1.)

 end do t

  comp loglike_dr(draws) = loglike_kf
* comp loglikel((draws-1)*ndraws1+draws1) = loglike_dr(draws)

 do draws1 = 1,ndraws1

 comp u2(t1) = %ran(1.)
 compute theta_mc(t1) = theta_ka(t1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,DIM_LAM
 compute lambda(t1)(sp) = theta_mc(t1)(sp)
 end do sp

 do sp = dim_lam+1,n+dim_lam
 compute alfa_1(t1)(sp-dim_lam) = theta_mc(t1)(sp)
 end do sp


 do t = 2,t1
 comp u2(t1-t+1) = %ran(1.)
  compute themean=theta_ka(t1-t+1)+emme_mc(t1-t+1)* $
	       (theta_mc(t1-t+2)-theta_ka(t1-t+1))
  compute theta_mc(t1-t+1) = themean+%decomp(omega_mc(t1-t+1))*u2(t1-t+1)
  compute themean = %const(.0)

* compute theta_mc(t1-t+1) = theta_ka(t1-t+1) ;*+%decomp(omega_ka(t1))*u2(t1)

  do sp = 1,dim_lam
  compute lambda(t1-t+1)(sp) = theta_mc(t1-t+1)(sp)
  end do sp

  do sp = dim_lam+1,n+dim_lam
  compute alfa_1(t1-t+1)(sp-dim_lam) = theta_mc(t1-t+1)(sp)
  end do sp

 end do t

* compute theta_ka(1) = theta_mc(1)

 compute part5 = %const(.0)
 compute part6 = .0
 compute part7 = .0, part8 = .0, part9 = 0.0
 comp sum_sig = 0., sum_eome = 0.0

 DO T = 2,t1

  compute eps1 = smally(t)-big_w(t)*lambda(t)-big_a(t)*alfa_1(t)
  comp eps_eps = eps1*tr(eps1)
  comp part6 = zeta*s_t(t)+%qform(omega,eps1)

  compute p00 = 2./(part6)
*  compute hetero(t) = p00*%rangamma(.5*(ng+zeta))
 compute hetero(t) = 1.
  compute part5 = part5+(hetero(t))*eps_eps

  compute eps1 = %const(.0)

  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute resth = (1./delta_t)*(theta_mc(t)-theta_mc(t-1))
  compute resth1 = (1./delta_t)*(lambda(t)-lambda(t-1))
  compute resth3 = (1./delta_t)*(alfa_1(t)-alfa_1(t-1))

  compute part7 = part7+%dot(resth1,resth1)
  compute part9 = part9+%dot(resth3,resth3)

end do t

 compute seps1 = part7+d_0
 compute p11= 2./(seps1)
 compute phi1 = p11*%rangamma(.5*(t1+v_0))
 compute phi_1 = %mscalar(1./phi1)

 compute seps3 = part9+d_0
 compute p3= 2./(seps3)
 compute phi3 = p3*%rangamma(.5*(t1*n+v_0))
 compute phi_3 = %mscalar(1./phi3)

 comp big_phi = %const(.0)
*
 do i = 1,dim_lam
 comp big_phi(i,i) = phi_1(i,i)
 end do lam

 do i = 1,n
 comp big_phi(i+dim_lam,i+dim_lam) = phi_3(i,i)
 end

 comp big_phiinv = inv(big_phi)
*

 compute werre_0 = w_0*sigma_eps
 compute ss0hatinv = werre_0+part5
 compute Swish = tr(%decomp(inv(ss0hatinv)))
 compute omega = %mqform(%RANWISHART(N*g,def1),Swish)

end do draws1

 compute phi1dra(draws) = 1./phi1
 compute phi3dra(draws) = 1./phi3
 compute omega_dra(draws) = omega

 do t = 2,ti
  compute lamdraw(t,draws) = lambda(t)
  compute alfadraw(t,draws) = alfa_1(t)
  compute hetero_dra(t,draws) = hetero(t)
 end

 infobox(current=draws)
end do draws
infobox(action=remove)


** compute log of marginal likelihood using harmonic mean
*
smpl 1 ndraws
clear malik1
do draws = 1,mindraws
set malik1 draws draws = loglike_dr(begdraws+draws)
end
stat(noprint,fract) malik1
comp max1 = %maximum
disp 'max' %maximum
disp 'min' %minimum
comp const = %median

smpl 1 ndraws
clear malik
do draws = 1,mindraws
if loglike_dr(begdraws+draws)-const>700
{
set malik draws draws = exp(700)
}
else if loglike_dr(begdraws+draws)-const<-450
{
set malik draws draws = exp(-450)
}
else
set malik draws draws = 1./exp(loglike_dr(begdraws+draws)-const)
end

stat(noprint,fract) malik
comp ML_HM = log(1./%mean)+const
*comp ML_HM = log(1./((1./mindraws)*%sum(malik)))+const
disp 'log of Marg_Like with harmonic mean'
disp 'HaM' ML_HM

/*
** simple mean
smpl 1 ndraws
clear malik
do draws = 1,mindraws
set malik draws draws = exp(loglike_dr(begdraws+draws)-const)
end

stat(noprint,fract) malik
comp ML_SM = log(%mean)+const

disp 'log of Marg_Like with simple mean'
disp 'SiM' ML_SM
*/

/*
smpl 1 ndraws*ndraws1
clear malik2
do draws = 1,ndraws*ndraws1
set malik2 draws draws = loglikel(draws+10000)
end
stat(fract) malik2
disp 'max' %maximum
disp 'min' %minimum
comp const2 = %median

smpl 1 ndraws*ndraws1
clear malik3
do draws = 1,ndraws*ndraws1
set malik3 draws draws = 1./exp(loglikel(draws+10000)-const2)
end

stat(noprint,fract) malik3
comp ML_HM = log(1./%mean)+const2
disp 'log of Marg_Like with harmonic mean'
disp ML_HM

*/


** compute the empirical modal value to be used in chib's measure of ML
*
***************************************
dec vec[vec] theta_post(ti)
do t = 1,ti
dim theta_post(t)(k_1)
comp theta_post(t) = %const(.0)
end

dec symm omega_star(ng,ng)

dec vec new_loglike(mindraws)
do draws = 1,mindraws
comp new_loglike(draws) = loglike_dr(draws+begdraws)
end

comp max = %maxvalue(new_loglike)
do draws = 1,mindraws
if max == new_loglike(draws)
{
disp draws max
do t = 1,ti
do sp = 1,dim_lam
compute theta_post(t)(sp) = lamdraw(t,draws+begdraws-1)(sp)
end
end

do t = 1,ti
do sp = dim_lam+1,dim_lam+n
compute theta_post(t)(sp) = alfadraw(t,draws+begdraws-1)(sp-dim_lam)
end
end

comp omega_star = omega_dra(draws+begdraws-1)
compute fi1_star = phi1dra(draws+begdraws-1)
compute fi3_star = phi3dra(draws+begdraws-1)

 do i = 1,dim_lam
 comp big_phi(i,i) = fi1_star
 end do lam

 do i = 1,n
 comp big_phi(i+dim_lam,i+dim_lam) = fi3_star
 end

}
end do draws

dec vec hetero_post(ti)
comp hetero_post = %const(1.0)

*
do t = 2,t1
 do sp = 1,DIM_LAM
  compute lambda(t)(sp) = theta_post(t)(sp)
 end do sp

 do sp = dim_lam+1,n+dim_lam
  compute alfa_1(t)(sp-dim_lam) = theta_post(t)(sp)
 end do sp

end do t

/*
dec vec[vec] theta_post(ti)
do t = 1,ti
dim theta_post(t)(k_1)
comp theta_post(t) = %const(.0)
end

do t = 1,ti
do sp = 1,dim_lam
do draws = 1,mindraws
compute theta_post(t)(sp) = theta_post(t)(sp)+(1./ndraws)*lamdraw(t,begdraws+draws)(sp)
end
end
end

do t = 1,ti
do sp = dim_lam+1,dim_lam+n
do draws = 1,mindraws
  compute theta_post(t)(sp) = theta_post(t)(sp)+(1./ndraws)*alfadraw(t,begdraws+draws)(sp-dim_lam)
end
end
end

dec symm omega_star(ng,ng)

comp omega_star = %const(.0)
do draws = 1,mindraws
comp omega_star = omega_star + (1./mindraws)*omega_dra(draws+begdraws)
end

dec vec hetero_post(ti)
comp hetero_post = %const(.0)

do t = 2,ti
do draws = 1,mindraws
compute hetero_post(t) = hetero_post(t)+(1./mindraws)*hetero_dra(t,begdraws+draws)
end
end


clear fi1 fi3
  do draws = 1,mindraws
   set fi1 draws draws = phi1dra(draws+begdraws)
   set fi3 draws draws = phi3dra(draws+begdraws)
 end do draws

stat(noprint) fi1
compute fi1_star = %mean

stat(noprint) fi3
compute fi3_star = %mean

 do i = 1,dim_lam
 comp big_phi(i,i) = fi1_star
 end do lam

 do i = 1,n
 comp big_phi(i+dim_lam,i+dim_lam) = fi3_star
 end

disp fi1_star fi3_star
*/

/*
* compute here loglike that integrates out the latent variable
* TO double CHECK that the one computed above matches with modal value
 compute omega_ka(1) = %IDENTITY(K_1)
 compute omegaTT_1 = omega_ka(1)+big_phi
 compute emme_mc(1) = omega_ka(1)*inv(omegaTT_1)
 compute omega_mc(1) = omega_ka(1)-%mqform(omegaTT_1,tr(emme_mc(1)))

 comp loglike_kf_post = 0.0

* compute theta_ka(2) = theta_post(2)
 do t = 2,t1
  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute omegaTT_1 = omega_ka(t-1)+delta_t*big_phi
  compute effeTT_1 = X_M(t)*omegaTT_1*tr(X_M(t))+(1./hetero(t))*inv(omega_star)
  compute kappaTT_1 = omegaTT_1*tr(X_M(t))*inv(effeTT_1)
  compute imenoka = %identity(k_1)-kappaTT_1*X_M(t)
  compute omega_ka(t) = imenoka*omegaTT_1

  compute resi = smally(t)-X_M(t)*theta_ka(t-1)
  compute theta_ka(t) = theta_ka(t-1)+kappaTT_1*resi
  compute delta_t1 = arch4**(t+1)+arch3*(1./(1.-arch4))*(1.-arch4**(t+1))
  compute omegaTT_11 = omega_ka(t)+delta_t1*big_phi
  compute emme_mc(t) = omega_ka(t)*inv(omegaTT_11)
  compute omega_mc(t)= omega_ka(t)-%mqform(omegaTT_11,tr(emme_mc(t)))

  compute resi1 = smally(t)-X_M(t)*theta_ka(t)
  comp loglike_kf_TEMP = -0.5*n*g*log(2.*%pi)-0.5*log(%det(effeTT_1))-0.5*%qform(inv(effeTT_1),resi)
  comp loglike_kf_post = loglike_kf_post + loglike_kf_TEMP
END DO T

DISP loglike_kf_post max
*/

/* another way of integrating out theta
comp sum_sig = 0., sum_eome = 0.0
comp eps1 = %const(.0), eps_eps = %const(.0)

DO T = 2,t1
 compute eps1 = smally(t)-X_M(t)*theta_post(2)
 comp eps_eps = eps1*tr(eps1)
 comp temp = (1./hetero_post(t))*inv(omega_star)+(ti-2)*%mqform(big_phi,tr(X_M(t)))
 compute sum_sig = sum_sig+log(%det(temp))
 comp sum_eome = sum_eome +%qform(inv(temp),eps1)
end

** here compute log prior and log likelihood to use Chib approach
*
comp loglike1 = -0.5*n*g*ti*log(2.*%pi)-0.5*sum_sig-0.5*sum_eome
disp loglike1
*/
*
*
** evaluate the prior at the modal value or take saved values if seeds is different from 10
*
if seeds == 10
{
comp product = 0.
do i = 1,ng
comp product = product+%LNGAMMA(0.5*(w_0+1-i))
end

compute v_0 = 10., d_0 = 1.0  ;* shape and scale sigma_2. set to zero for a non informative prior
compute werre_0 = w_0*sigma_eps
comp konst_wish = -((0.5*w_0*ng)*log(2.)+0.25*ng*(ng-1)*log(%pi)+product)
comp logprior_wish = konst_wish+0.5*(w_0-ng-1)*log(%det(omega_star))-0.5*w_0*log(%det(inv(werre_0)))-0.5*%trace((werre_0)*omega_star)
disp logprior_wish

comp logprior_phi = 2.*0.5*v1_0*log(0.5*d1_0)-2.*%LNGAMMA(0.5*v1_0)-(0.5*v1_0-1)*(log(fi1_star)+log(fi3_star))- $
               0.5*d1_0*((1./fi1_star)+(1./fi3_star))
comp logprior = logprior_wish+logprior_phi
disp logprior_phi
disp max+logprior

comp omega_vec = %vec(omega_star)
comp phi_vec = %vec(big_phi)

open copy theta_star_5.TXT
write(unit=copy) theta_post(2)
CLOSE COPY

open copy omega_star_5.TXT
write(unit=copy) omega_VEC
CLOSE COPY

open copy phi_star_5.txt
write(unit=copy) phi_vec
CLOSE COPY

open copy log_lipr_5.txt
write(unit=copy) max logprior
close copy
}
end if

dec vec omega_rec(ng*(ng+1)/2)
dec vec phi_rec(k_1*(k_1+1)/2)
dec vec lik_pr(2)
dec vec theta_st(k_1)

if seeds<>10
{
open DATA theta_star_5.TXT
READ(UNIT=DATA) theta_st
CLOSE DATA

open DATA log_lipr_5.TXT
READ(UNIT=DATA) lik_pr
CLOSE DATA

open DATA omega_star_5.TXT
READ(UNIT=DATA) OMEGA_REC
CLOSE DATA

open DATA phi_star_5.TXT
READ(UNIT=DATA) phi_REC
CLOSE DATA

comp theta_post(2)= theta_st
comp omega_star = %vectosymm(omega_rec,ng)
comp big_phi = %vectosymm(phi_rec,k_1)
comp fi1_star = big_phi(1,1)
comp fi3_star = big_phi(dim_lam+1,dim_lam+1)
comp max = lik_pr(1), logprior = lik_pr(2)
}
end if

dec vec post1(ndraws)
comp product = 0.
do i = 1,ng
 comp product = product+%LNGAMMA(0.5*(def1+1-i))
end
comp konst_wish = -((0.5*def1*ng)*log(2.)+0.25*ng*(ng-1)*log(%pi)+product)

*
infobox(action=define,progress,lower=1,upper=ndraws) 'Monte Carlo Integration - STEP 1'
do draws = 1,ndraws


 do t = 1,ti
 dim u2(t)(k_1)
 end do t

*
** kalman filter
*
 compute omega_ka(1) = %IDENTITY(K_1)
 compute omegaTT_1 = omega_ka(1)+big_phi
 compute emme_mc(1) = omega_ka(1)*inv(omegaTT_1)
 compute omega_mc(1) = omega_ka(1)-%mqform(omegaTT_1,tr(emme_mc(1)))
 comp u2(1) = %ran(1.)

 do t = 2,t1
  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute omegaTT_1 = omega_ka(t-1)+delta_t*big_phi
  compute effeTT_1 = X_M(t)*omegaTT_1*tr(X_M(t))+(1./hetero(t))*inv(omega)
  compute kappaTT_1 = omegaTT_1*tr(X_M(t))*inv(effeTT_1)
  compute imenoka = %identity(k_1)-kappaTT_1*X_M(t)
  compute omega_ka(t) = imenoka*omegaTT_1

  compute resi = smally(t)-X_M(t)*theta_ka(t-1)
  compute theta_ka(t) = theta_ka(t-1)+kappaTT_1*resi
  compute delta_t1 = arch4**(t+1)+arch3*(1./(1.-arch4))*(1.-arch4**(t+1))
  compute omegaTT_11 = omega_ka(t)+delta_t1*big_phi
  compute emme_mc(t) = omega_ka(t)*inv(omegaTT_11)
  compute omega_mc(t)= omega_ka(t)-%mqform(omegaTT_11,tr(emme_mc(t)))
  release resi omegaTT_1 effeTT_1 kappaTT_1 imenoka omegatt_11
  comp u2(t) = %ran(1.)
 end do t

do draws1 = 1,ndraws1
*DISP DRAWS DRAWS1
 comp u2(t1) = %ran(1.)
 compute theta_mc(t1) = theta_ka(t1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,DIM_LAM
 compute lambda(t1)(sp) = theta_mc(t1)(sp)
 end do sp

 do sp = dim_lam+1,n+dim_lam
 compute alfa_1(t1)(sp-dim_lam) = theta_mc(t1)(sp)
 end do sp


 do t = 2,t1
 comp u2(t1-t+1) = %ran(1.)
  compute themean=theta_ka(t1-t+1)+emme_mc(t1-t+1)* $
	       (theta_mc(t1-t+2)-theta_ka(t1-t+1))
  compute theta_mc(t1-t+1) = themean+%decomp(omega_mc(t1-t+1))*u2(t1-t+1)
  compute themean = %const(.0)

* compute theta_mc(t1-t+1) = theta_ka(t1-t+1) ;*+%decomp(omega_ka(t1))*u2(t1)

do sp = 1,dim_lam
  compute lambda(t1-t+1)(sp) = theta_mc(t1-t+1)(sp)
  end do sp

  do sp = dim_lam+1,n+dim_lam
  compute alfa_1(t1-t+1)(sp-dim_lam) = theta_mc(t1-t+1)(sp)
  end do sp


 end do t

* compute theta_ka(1) = theta_mc(1)

 compute part5 = %const(.0)
 compute part6 = .0
 compute part7 = .0, part8 = .0, part9 = 0.0
comp sum_sig = 0., sum_eome = 0.0

 DO T = 2,t1

  compute eps1 = smally(t)-big_w(t)*lambda(t)-big_a(t)*alfa_1(t)
  comp eps_eps = eps1*tr(eps1)
  comp part6 = zeta*s_t(t)+%qform(omega,eps1)

  compute p00 = 2./(part6)
* compute hetero(t) = p00*%rangamma(.5*(ng+zeta))
  compute hetero(t) = 1.
  compute part5 = part5+(hetero(t))*eps_eps

  compute sum_sig = sum_sig+log(1./hetero(t))
  comp sum_eome = sum_eome +(hetero(t))*%qform(omega,eps1)

  compute eps1 = %const(.0)

  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute resth = (1./delta_t)*(theta_mc(t)-theta_mc(t-1))
  compute resth1 = (1./delta_t)*(lambda(t)-lambda(t-1))
  compute resth3 = (1./delta_t)*(alfa_1(t)-alfa_1(t-1))

  compute part7 = part7+%dot(resth1,resth1)
  compute part9 = part9+%dot(resth3,resth3)

 end do t

 compute seps1 = part7+d_0
 compute p11= 2./(seps1)
 compute phi1 = p11*%rangamma(.5*(t1+v_0))
 compute phi_1 = %mscalar(1./phi1)

 compute seps3 = part9+d_0
 compute p3= 2./(seps3)
 compute phi3 = p3*%rangamma(.5*(t1*n+v_0))
 compute phi_3 = %mscalar(1./phi3)


 comp big_phi = %const(.0)
*
 do i = 1,dim_lam
 comp big_phi(i,i) = phi_1(i,i)
 end do lam

 do i = 1,n
 comp big_phi(i+dim_lam,i+dim_lam) = phi_3(i,i)
 end

 comp big_phiinv = inv(big_phi)
*

 compute werre_0 = w_0*sigma_eps
 compute ss0hatinv = werre_0+part5
 compute Swish = tr(%decomp(inv(ss0hatinv)))
 compute omega = %mqform(%RANWISHART(N*g,def1),Swish)
* compute omega_dra(draws) = omega

end do draws1

comp post1(draws) = konst_wish+0.5*(def1-ng-1)*log(%det(omega_star))-0.5*def1*log(%det(inv(ss0hatinv)))-0.5*%trace((ss0hatinv)*omega_star)

 infobox(current=draws)
end do draws
infobox(action=remove)


smpl 1 ndraws
clear postwish
do draws = 1,mindraws
set postwish draws draws = post1(begdraws+draws)
end
stat(print,fract) postwish
comp const = %median

clear postwi
clear postwi
do draws = 1,mindraws
if post1(begdraws+draws)-const>700
{
set postwi draws draws = exp(700)
}
else if post1(begdraws+draws)-const<-450
{
set postwi draws draws = exp(-450)
}
else
set postwi draws draws = exp(post1(begdraws+draws)-const)
end

comp logpost_wish = log((1./mindraws)*%sum(postwi))+const
*stat(print,fract) postwi
*comp logpost_wish = log(%mean)+const
*comp logpost_wish = post1/(ndraws)
disp logprior_wish logpost_wish


******************************************
****** last MCMC ROUTINE for chib method
******************************************

dec vec post2(ndraws)
*
infobox(action=define,progress,lower=1,upper=ndraws) 'Monte Carlo Integration - STEP 2'
do draws = 1,ndraws


compute theta_ka(2) = theta_post(2)
*
** kalman filter
*
 compute omega_ka(1) = %IDENTITY(K_1)
 compute omegaTT_1 = omega_ka(1)+big_phi
 compute emme_mc(1) = omega_ka(1)*inv(omegaTT_1)
 compute omega_mc(1) = omega_ka(1)-%mqform(omegaTT_1,tr(emme_mc(1)))
 comp u2(1) = %ran(1.)

 do t = 3,t1
  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute omegaTT_1 = omega_ka(t-1)+delta_t*big_phi
  compute effeTT_1 = X_M(t)*omegaTT_1*tr(X_M(t))+(1./hetero(t))*inv(omega_star)
  compute kappaTT_1 = omegaTT_1*tr(X_M(t))*inv(effeTT_1)
  compute imenoka = %identity(k_1)-kappaTT_1*X_M(t)
  compute omega_ka(t) = imenoka*omegaTT_1

  compute resi = smally(t)-X_M(t)*theta_ka(t-1)
  compute theta_ka(t) = theta_ka(t-1)+kappaTT_1*resi
  compute delta_t1 = arch4**(t+1)+arch3*(1./(1.-arch4))*(1.-arch4**(t+1))
  compute omegaTT_11 = omega_ka(t)+delta_t1*big_phi
  compute emme_mc(t) = omega_ka(t)*inv(omegaTT_11)
  compute omega_mc(t)= omega_ka(t)-%mqform(omegaTT_11,tr(emme_mc(t)))
  release resi omegaTT_1 effeTT_1 kappaTT_1 imenoka omegatt_11
  comp u2(t) = %ran(1.)
 end do t

*do draws1 = 1,ndraws1
*DISP DRAWS DRAWS1
 comp u2(t1) = %ran(1.)
 compute theta_mc(t1) = theta_ka(t1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,DIM_LAM
 compute lambda(t1)(sp) = theta_mc(t1)(sp)
 end do sp

 do sp = dim_lam+1,n+dim_lam
 compute alfa_1(t1)(sp-dim_lam) = theta_mc(t1)(sp)
 end do sp


 do t = 2,t1
 comp u2(t1-t+1) = %ran(1.)
  compute themean=theta_ka(t1-t+1)+emme_mc(t1-t+1)* $
	       (theta_mc(t1-t+2)-theta_ka(t1-t+1))
  compute theta_mc(t1-t+1) = themean+%decomp(omega_mc(t1-t+1))*u2(t1-t+1)
  compute themean = %const(.0)

* compute theta_mc(t1-t+1) = theta_ka(t1-t+1) ;*+%decomp(omega_ka(t1))*u2(t1)

 do sp = 1,dim_lam
  compute lambda(t1-t+1)(sp) = theta_mc(t1-t+1)(sp)
  end do sp

  do sp = dim_lam+1,n+dim_lam
  compute alfa_1(t1-t+1)(sp-dim_lam) = theta_mc(t1-t+1)(sp)
  end do sp

 end do t

* compute theta_ka(1) = theta_mc(1)

 compute part5 = %const(.0)
 compute part6 = .0
 compute part7 = .0, part8 = .0, part9 = 0.0
 comp sum_sig = 0., sum_eome = 0.0

 DO T = 2,t1

  compute eps1 = smally(t)-big_w(t)*lambda(t)-big_a(t)*alfa_1(t)
  comp eps_eps = eps1*tr(eps1)
  comp part6 = zeta*s_t(t)+%qform(omega_star,eps1)

  compute p00 = 2./(part6)
* compute hetero(t) = p00*%rangamma(.5*(ng+zeta))
  compute hetero(t) = 1.
  compute part5 = part5+(hetero(t))*eps_eps

  compute sum_sig = sum_sig+log(1./hetero(t))
  comp sum_eome = sum_eome +(hetero(t))*%qform(omega_star,eps1)

  compute eps1 = %const(.0)

  compute delta_t = arch4**t+arch3*(1./(1.-arch4))*(1.-arch4**t)
  compute resth = (1./delta_t)*(theta_mc(t)-theta_mc(t-1))
  compute resth1 = (1./delta_t)*(lambda(t)-lambda(t-1))
  compute resth3 = (1./delta_t)*(alfa_1(t)-alfa_1(t-1))

  compute part7 = part7+%dot(resth1,resth1)
  compute part9 = part9+%dot(resth3,resth3)

end do t

 compute seps1 = part7+d_0
 compute p11= 2./(seps1)
 compute phi1 = p11*%rangamma(.5*(t1+v_0))
 compute phi_1 = %mscalar(1./phi1)

 compute seps3 = part9+d_0
 compute p3= 2./(seps3)
 compute phi3 = p3*%rangamma(.5*(t1*n+v_0))
 compute phi_3 = %mscalar(1./phi3)

 comp big_phi = %const(.0)
*
 do i = 1,dim_lam
 comp big_phi(i,i) = phi_1(i,i)
 end do lam

 do i = 1,n
 comp big_phi(i+dim_lam,i+dim_lam) = phi_3(i,i)
 end

 comp big_phiinv = inv(big_phi)
*

*end do draws1

comp post2(draws) =  0.5*((t1+v_0)*log(0.5*seps1)+(t1*n+v_0)*log(0.5*seps3))- $
               (%LNGAMMA(0.5*(t1+v_0))+%LNGAMMA(0.5*(t1*n+v_0)))- $
               ((0.5*(t1+v_0)-1)*log(fi1_star)+(0.5*(t1*n+v_0)-1)*log(fi3_star))- $
               0.5*(seps1*(1./fi1_star)+seps3*(1./fi3_star))

 infobox(current=draws)
end do draws
infobox(action=remove)


smpl 1 ndraws
clear postB
do draws = 1,mindraws
set postB draws draws = post2(begdraws+draws)
end
stat(print,fract) postB
comp const = %median

clear post_B
do draws = 1,mindraws
set post_B draws draws = exp(post2(begdraws+draws)-const)
end

stat(noprint,fract) post_B
comp logpost_phi = log(%mean)+const
*comp logpost_phi = post2/ndraws
disp logprior_phi logpost_phi

*comp marg_like1 = loglike1+logprior-logpost_wish-logpost_phi
comp marg_like = max+logprior-logpost_wish-logpost_phi
disp 'Log Marg_Like with Chib'
disp marg_like
disp 'Log max likelihood'
disp max1
disp 'Marg_Like with harmonic mean'
disp ML_HM

*











